# Auto Close Doors (Server-Only)

Original mod by [Kaltharos](https://v-rising.thunderstore.io/package/Kaltharos/). Ported to Gloomrot by [p1xel8ted](https://v-rising.thunderstore.io/package/p1xel8ted/).

## Feature

- Auto-close doors after a certain amount of time.

## Installation

1. Install [BepInExPack V Rising](https://v-rising.thunderstore.io/package/BepInEx/BepInExPack_V_Rising/)
2. Install [Bloodstone API](https://v-rising.thunderstore.io/package/deca/Bloodstone/)
3. Install [VampireCommandFramework](https://v-rising.thunderstore.io/package/deca/VampireCommandFramework/)
3. Place the `AutoCloseDoors.dll`, `Bloodstone.dll` & `VampireCommandFramework.dll` files into your `(VRising server folder)/BepInEx/plugins` folder.
4. Done!

## Removal
If your server is on Windows or can be shut down properly, all you need to do to remove the mod is shut down your server and delete the DLL.

If your server is on Linux, or can't be shut down properly:

1. Make sure to change the config of `Enable Uninstall` to `true`.
2. Restart your server, and then execute the uninstallation command `~autoclosedooruninstall`.
3. After the uninstallation is complete, shut down your server and remove the DLL.

## Config

- `Enable Auto Close Doors` [default `true`]\
Switch on/off auto close for doors.

- `Auto Close Timer` [default `2.0`]\
How many seconds (s) to wait before the door is automatically closed.
- `Always Auto Close Doors` [default `false`]\
When this is set to false, doors will not automatically close if the castle is decaying, under attack, or being sieged.
- `Enable Uninstall` [default `false`]\
Do not enable for better performance on the server.\
This uninstallation method is only required on servers that can't shut down properly, like VRising on Linux Wine.\
On Windows, servers can be shut down properly, and all doors are by default reverted back to normal on server shutdown.
- `Uninstall Command` (`~autoclosedooruninstall`)\
Chat command to uninstall the mod. Only work if "Enable Uninstall" is set to true & the user is an Admin (adminauth).

## Commands

`autoclosedooruninstall`\
Revert all doors in the game world to not close automatically.

## Known Issues
- When doors are built for the first time, the user will need to open the door twice for the door to open.

